'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _object = require('object.entries');

var _object2 = _interopRequireDefault(_object);

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _splitByLastDot = require('./helpers/splitByLastDot');

var _splitByLastDot2 = _interopRequireDefault(_splitByLastDot);

var _isConstrutor = require('./helpers/isConstrutor');

var _isConstrutor2 = _interopRequireDefault(_isConstrutor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var cwd = process.cwd();

var mapRoutes = function mapRoutes(routes, pathToController) {
  var router = _express2.default.Router();
  var requestMethodPath = void 0;
  var requestMethod = void 0;

  var controllerMethod = void 0;
  var controller = void 0;
  var contr = void 0;

  var handler = void 0;

  var myPath = void 0;
  var myPathToController = _path2.default.join(cwd, pathToController);

  var routesArr = (0, _object2.default)(routes);

  routesArr.forEach(function (value) {
    requestMethodPath = value[0].replace(/\s\s+/g, ' ');
    requestMethod = requestMethodPath.split(' ')[0].toLocaleLowerCase();
    myPath = requestMethodPath.split(' ')[1];
    controller = (0, _splitByLastDot2.default)(value[1])[0];
    controllerMethod = (0, _splitByLastDot2.default)(value[1])[1];

    try {
      handler = require('' + myPathToController + controller);

      var isConstructable = (0, _isConstrutor2.default)(handler);

      if (isConstructable) {
        contr = new handler();
      } else {
        contr = handler();
      }
    } catch (err) {
      require('babel-register');
      handler = require('' + myPathToController + controller).default;
      contr = new handler();
    }

    if (requestMethod === 'get') {
      router.route(myPath).get(contr[controllerMethod]);
    } else if (requestMethod === 'post') {
      router.route(myPath).post(contr[controllerMethod]);
    } else if (requestMethod === 'put') {
      router.route(myPath).put(contr[controllerMethod]);
    } else if (requestMethod === 'delete') {
      router.route(myPath).delete(contr[controllerMethod]);
    }
  });

  return router;
};

exports.default = mapRoutes;
module.exports = exports['default'];